/**
a foggy wood by <a href="http://www.local-guru.net/blog">guru</a>
*/
import java.util.Vector;
Branch root[];
PVector pos[];

void setup() {
  size(600,300,P2D);
  smooth();
  root =  new Branch[20];
  pos = new PVector[20];
  for( int i =0; i < 20; i++ ) {
    root[i] = new Branch( 20 + (int)random(30), 0);
    createTree( root[i], 0);
    pos[i] = new PVector( random( width), i* float(height/40));
  }
}

void draw() {
  background(255);
  pushMatrix();
  translate(width/2,height);
  rotate( PI );
  for( int i=19; i >=0; i--) {
     pushMatrix();
     translate( pos[i].x - width/2, pos[i].y);
     scale( 1 - (pos[i].y*1.5/height));
     stroke(255*sqrt(pos[i].y/height));
     strokeWeight(2-3*sqrt(pos[i].y/height));
     root[i].draw();  
     popMatrix();
  }
  popMatrix();
}

void createTree( Branch root, int rec ) {
  int c = 1 + (int)random(4-rec);
  
  for( int i=0; i < c; i++) {
    root.addBranch( new Branch( 10 - rec*2 + (int)random(20), rec+1 )); 
  }
  if (rec < 5 ) {
  for( int i=0; i < c; i++) {
    createTree(root.get(i), rec+1); 
  }
  }
}

class Branch {
  Vector branches = new Vector();
  int l;
  int depth;
  
  public Branch( int l, int depth ) {
    this.l = l;
    this.depth = depth;
  }
  
  public void addBranch( Branch b ) {
    branches.add( b );
  }
  
  public Branch get( int idx ) {
    return (Branch)branches.get(idx);
  }
  
  void draw() {
    line(0,0,0,l);
    for( int i=0; i < branches.size(); i++) {
      pushMatrix();

      translate( 0,l);
      rotate( radians( i * (120/float(depth+1) )/ branches.size() - (30.0/float(depth+1))) + (noise( frameCount/100.0 )-0.5 + noise(random(0.1)))/10);
    
      get(i).draw();
      popMatrix();

    }
    
  }
  
}

void keyPressed() {
  root =  new Branch[20];
  pos = new PVector[20];
  for( int i =0; i < 20; i++ ) {
    root[i] = new Branch( 20 + (int)random(30), 0);
    createTree( root[i], 0);
    pos[i] = new PVector( random( width), i* float(height/40));
  }
}
